#include <iostream>
#include <vector>
#include <set>
#include <queue>

using namespace std;

struct Edge {
    int from, to;
};

int main() {
    int nodeCount = 0;
    int edgeCount = 0;
    cin >> nodeCount >> edgeCount;

    vector<set<int>> edges;
    vector<bool> possibleStart;
    vector<bool> possibleEnd;
    edges.reserve(nodeCount + 1);
    possibleStart.reserve(nodeCount + 1);
    possibleEnd.reserve(nodeCount + 1);
    for (int i = 0; i <= nodeCount; ++i) {
        edges.emplace_back(set<int>());
        possibleStart.emplace_back(true);
        possibleEnd.emplace_back(true);
    }
    possibleStart.at(0) = false;

    for (int i = 0; i < edgeCount; ++i) {
        int from, to;
        cin >> from >> to;
        edges.at(from).insert(to);
        possibleStart.at(to) = false;
        possibleEnd.at(from) = false;
    }

    int start = -1;
    int end = -1;
    for (int i = 1; i <= nodeCount; ++i) {
        if (possibleStart.at(i)) {
            start = i;
            break;
        }
    }

    for (int i = 1; i <= nodeCount; ++i) {
        if (possibleEnd.at(i)) {
            end = i;
            break;
        }
    }
    if (start == -1 || end == -1) {
        cout << "FAIL" << endl;
    }

    queue<int> queue;
    queue.push(start);
    set<int> open;
    open.insert(start);

    int removeCount = 0;
    while (!queue.empty()) {
        int pos = queue.front();
        queue.pop();
        for (int nb : edges.at(pos)) {
            if (open.count(nb) == 0) {
                queue.push(nb);
                open.insert(nb);
            } else if (nb != end) {
                cout << pos << ", " << nb << endl;
                removeCount++;
            }
        }
    }

    cout << removeCount << endl;
    return 0;
}